# ss-tunnel(1)

## NAME

ss-tunnel - shadowsocks tools for local port forwarding, libev port

## SYNOPSIS

ss-tunnel [-uUv6] [-h|--help] [-s <emphasis><server_host></emphasis>] [-p <emphasis><server_port></emphasis>] [-l <emphasis><local_port></emphasis>] [-k <emphasis><password></emphasis>] [-m <emphasis><encrypt_method></emphasis>] [-f <emphasis><pid_file></emphasis>] [-t <emphasis><timeout></emphasis>] [-c <emphasis><config_file></emphasis>] [-i <emphasis><interface></emphasis>] [-b <emphasis><local_address></emphasis>] [-a <emphasis><user_name></emphasis>] [-n <emphasis><nofile></emphasis>] [-L addr:port] [--mtu <emphasis><MTU></emphasis>] [--mptcp] [--reuse-port] [--no-delay] [--plugin <emphasis><plugin_name></emphasis>] [--plugin-opts <emphasis><plugin_options></emphasis>] [--key <emphasis><key_in_base64></emphasis>]

## DESCRIPTION

Shadowsocks-libev is a lightweight and secure socks5 proxy. It is a port of the original shadowsocks created by clowwindy. Shadowsocks-libev is written in pure C and takes advantage of libev to achieve both high performance and low resource consumption.

Shadowsocks-libev consists of five components. `ss-tunnel`(1) is a tool for local port forwarding. See OPTIONS section for special option needed by `ss-tunnel`(1). For more information, check out `shadowsocks-libev`(8).

## OPTIONS

-s <emphasis><server_host></emphasis>

  Set the server’s hostname or IP.

-p <emphasis><server_port></emphasis>

  Set the server’s port number.

-l <emphasis><local_port></emphasis>

  Set the local port number.

-k <emphasis><password></emphasis>
--password <emphasis><password></emphasis>

  Set the password. The server and the client should use the same password.

--key <emphasis><key_in_base64></emphasis>

  Set the key directly. The key should be encoded with URL-safe Base64.

-m <emphasis><encrypt_method></emphasis>

  Set the cipher.

  Shadowsocks-libev accepts 19 different ciphers:

  aes-128-gcm, aes-192-gcm, aes-256-gcm, rc4-md5, aes-128-cfb, aes-192-cfb, aes-256-cfb, aes-128-ctr, aes-192-ctr, aes-256-ctr, bf-cfb, camellia-128-cfb, camellia-192-cfb, camellia-256-cfb, chacha20-ietf-poly1305, xchacha20-ietf-poly1305, salsa20, chacha20 and chacha20-ietf.

  The default cipher is chacha20-ietf-poly1305.

  If built with PolarSSL or custom OpenSSL libraries, some of these ciphers may not work.

-a <emphasis><user_name></emphasis>

  Run as a specific user.

-f <emphasis><pid_file></emphasis>

  Start shadowsocks as a daemon with specific pid file.

-t <emphasis><timeout></emphasis>

  Set the socket timeout in seconds. The default value is 60.

-c <emphasis><config_file></emphasis>

  Use a configuration file.

  Refer to `shadowsocks-libev`(8) CONFIG FILE section for more details.

-n <emphasis><number></emphasis>

  Specify max number of open files.

  Only available on Linux.

-i <emphasis><interface></emphasis>

  Send traffic through specific network interface.

  For example, there are three interfaces in your device, which is lo (127.0.0.1), eth0 (192.168.0.1) and eth1 (192.168.0.2). Meanwhile, you configure `ss-tunnel` to listen on 0.0.0.0:8388 and bind to eth1. That results the traffic go out through eth1, but not lo nor eth0. This option is useful to control traffic in multi-interface environment.

-b <emphasis><local_address></emphasis>

  Specify the local address to use while this client is making outbound connections to the server.

-u

  Enable UDP relay.

-U

  Enable UDP relay and disable TCP relay.

-6

  Resovle hostname to IPv6 address first.

-L <emphasis><addr:port></emphasis>

  Specify destination server address and port for local port forwarding.

  Only used and available in tunnel mode.

--mtu <emphasis><MTU></emphasis>

  Specify the MTU of your network interface.

--mptcp

  Enable Multipath TCP.

  Only available with MPTCP enabled Linux kernel.

--reuse-port

  Enable port reuse.

  Only available with Linux kernel > 3.9.0.

--no-delay

  Enable TCP_NODELAY.

--plugin <emphasis><plugin_name></emphasis>

  Enable SIP003 plugin. (Experimental)

--plugin-opts <emphasis><plugin_options></emphasis>

  Set SIP003 plugin options. (Experimental)

-v

  Enable verbose mode.

-h|--help

  Print help message.

## SEE ALSO

`ss-local`(1), `ss-server`(1), `ss-redir`(1), `ss-manager`(1), `shadowsocks-libev`(8), `iptables`(8), /etc/shadowsocks-libev/config.json

Last updated 2020-09-15 02:30:48 UTC